from DescriptorElement import DescriptorElement

__author__ = 'modlab'


class NboPOrb(DescriptorElement):
    description = "NBO derived px py pz orbital occupations and enegries"

    def __init__(self, **options):
        super(NboPOrb, self).__init__(**options)

    def calculate_elements(self, atom):
        occupations = atom.GetProp('p orbital occupations')
        occ_px, occ_py, occ_pz = occupations.split()
        energies = atom.GetProp('p orbital energies')
        en_px, en_py, en_pz = energies.split()
        return [float(occ_px), float(occ_py), float(occ_pz), float(en_px), float(en_py), float(en_pz)]