from DescriptorCreator_ETH_pKBHX.DescriptorCreator import AtomDescriptorCreator
from sklearn.gaussian_process import GaussianProcessRegressor
from sklearn.gaussian_process.kernels import ConstantKernel as C, Matern, WhiteKernel
from sklearn.externals import joblib

def don_train(trainingset,descriptor_elements,kernel,regressors_dir):
   # create the desciptor vectors
   adc = AtomDescriptorCreator(trainingset)
   for des in descriptor_elements:
        adc.create_property(des[0], **des[1]) 
   adc.create_descriptor_vectors_hbd_qctraining()
   # initialize the regression model
   reg = GaussianProcessRegressor(kernel=kernel, alpha=0.05, normalize_y=True)
   # train the model
   reg.fit(adc.X, adc.y)
   # store the model
   joblib.dump(reg,regressors_dir + 'donor_model.pkl')

def __main__():
# definition of donor training set
   don_training_set = 'training_sets/donors_database_training_set.3D.sdf'
# definition of the final descriptor combination
   d1 = ('GraphChargeShell', {'charge_type': 'cm5', 'n_shells': 2, 'use_cip_sort' : True})
   d2 = ('ChargeAutocorrelation', {'charge_type': 'cm5', 'rmin': 1, 'rmax': 10, 'step_size': 0.2})
   d3 = ('ChargeShell', {'charge_type': 'cm5', 'n_shells': 7})
   descriptor_elements = [d1, d2, d3]
# definition of the GPR kernel
   kernel = C(1.0, (1e-3, 1e3)) * Matern(length_scale=1.0, length_scale_bounds=(1e-2, 1e2), nu=0.5) + WhiteKernel(noise_level=0.05)
# define directory to store the regressor
   regressors_dir = 'regressors/'
# call the training function
   don_train(don_training_set,descriptor_elements,kernel,regressors_dir)


__main__()
